<?php

/**
 * The abstract class for owner types
 */
class TemplateAPIRoleOwnerPlugin extends TemplateApiOwnerType {

  /**
   * Permits access to an action and item
   *
   * @abstract
   *
   * @param $op
   * @param Template $template
   *
   * @return Bool
   *
   */
  public function access($op, Template $template) {
    global $user;

    if (isset($template->owner) && in_array($template->owner, $user->roles)) {
      return TRUE;
    }

    return FALSE;
  }

  /**
   * Get the values that can be an owner
   *
   * @return array
   */
  public function values() {
    return user_roles(TRUE);
  }
}
